{****************************************************************************************

"MassUpdateTopicFooters" HelpNDoc script. Copyright (c) IBE Software
--------------------------------------------------------------------
Change the kind of all topic footers in the currently opened project to one of the
following options:
- Display the project copyright
- Display a custom footer text
- Hide the footer

Customization:
--------------
* NEW_FOOTER_KIND => specify the new footer kind for the topics. 0 => display project
  copyright; 1 => display a custom text; 2 => hide the footer

****************************************************************************************}

const
  // Specify the new footer kind
  NEW_FOOTER_KIND = 2;  // (0 => project copyright; 1 => custom; 2 => hidden)

var
  // Current topic ID
  aTopicId: string;

begin
  // Get first topic
  aTopicId := HndTopics.GetTopicFirst();
  // Loop through all topics
  while aTopicId <> '' do
  begin
    // Update the topic
    HndTopics.SetTopicFooterKind(aTopicId, NEW_FOOTER_KIND);
    // Get next topic
    aTopicId := HndTopics.GetTopicNext(aTopicId);
  end;
end.