{****************************************************************************************

"MassUpdateTopicHeaders" HelpNDoc script. Copyright (c) IBE Software
--------------------------------------------------------------------
Change the kind of all topic headers in the currently opened project to one of the
following options:
- Display the topic title
- Display a custom header text
- Hide the header

Customization:
--------------
* NEW_HEADER_KIND => specify the new header kind for the topics. 0 => display topic
  title; 1 => display a custom header; 2 => hide the header

****************************************************************************************}

const
  // Specify the new header kind
  NEW_HEADER_KIND = 2;  // (0 => topic title; 1 => custom; 2 => hidden)

var
  // Current topic ID
  aTopicId: string;

begin
  // Get first topic
  aTopicId := HndTopics.GetTopicFirst();
  // Loop through all topics
  while aTopicId <> '' do
  begin
    // Update the topic
    HndTopics.SetTopicHeaderKind(aTopicId, NEW_HEADER_KIND);
    // Get next topic
    aTopicId := HndTopics.GetTopicNext(aTopicId);
  end;
end.